# Copyright (c) 2013, University of Bristol and University of Southampton.

from EStat.Templating import Template

class TemplateMeanImputation(Template):
    'For use as an example of an UNPRINCIPLED method of handling missing data! Creates a new column in which missing values are replaced by the mean of the original variable.'

    __version__ = '1.0.0'

    tags = ['Data manipulation']
    engines = ['Python_script']

    inputs = '''
variable_with_missing = DataVector('Variable with missing data: ')
variable_with_mean_imputation = Text('Name of new variable: ')
new_dataset = Text('Name of output dataset: ')
'''

    pythonscript = '''
import numpy

import EStat
from EStat.Templating import *
from EStat.DTAFile import DTAFile

retval = DTAFile()

retval.nobs = datafile.nobs
for k in datafile.variables.keys():
    retval.addvariable(k, data = datafile.variables[k]['data'])

var = numpy.ma.array(datafile.variables[variable_with_missing]['data'])

retval.addvariable(str(variable_with_mean_imputation), data = var.filled(var.mean()))

outputs[str(new_dataset)] = retval
'''
